/*-
 * Copyright (c) 2014 Mikolaj Izdebski
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <errno.h>
#include <pthread.h>

#if defined(__x86_64__)
__asm__(".symver pthread_testcancel,pthread_testcancel@GLIBC_2.2.5");
#elif defined(__i386__)
__asm__(".symver pthread_testcancel,pthread_testcancel@GLIBC_2.0");
#endif

int __nosync_fsync()
{
  pthread_testcancel();
  errno = 0;
  return 0;
}

int fdatasync() __attribute__((alias("__nosync_fsync")));
int fsync() __attribute__((alias("__nosync_fsync")));
int msync() __attribute__((alias("__nosync_fsync")));
int sync() __attribute__((alias("__nosync_fsync")));
int sync_file_range() __attribute__((alias("__nosync_fsync")));
